function CObj(y,x){
    this.obj = document.createElement('span'); 
    this.obj.className='span'; 
    this.img = document.createElement('img'); 
    this.img.style.position='absolute'; 
    this.img.src = rgrid.doot.src; 
    this.obj.appendChild(this.img); 
    rgrid.mobj.appendChild(this.obj); 

    this.x = x; 
    this.y = y; 
    this.L = 0; 
    this.T = 0; 
    this.xr = (this.x / 2) % 1 ? 1 : -1; 
    this.yr = (this.y / 2) % 1 ? 1 : -1; 
    this.xf = Math.random() * 4 + 1; 
    this.yf = Math.random() * 4 + 1; 

    //initialization function
    this.init = function (){ 
        this.L  = Math.round(this.x * rgrid.Nx); 
        this.T  = Math.round(this.y * rgrid.Ny); 
        this.obj.style.width  = Math.round(rgrid.Nx + 1) + 'px'; 
        this.obj.style.height = Math.round(rgrid.Ny + 1) + 'px'; 
        this.img.style.left   = Math.round(-this.L) + 'px'; 
        this.img.style.top    = Math.round(-this.T) + 'px'; 
    }

    // update object positions
    this.draw = function (){ 
        this.obj.style.left   =  Math.round(this.L + (-rgrid.nx / 4 + rgrid.xm) * (this.xr * this.xf)) + 'px'; 
        this.obj.style.top    =  Math.round(this.T + (-rgrid.ny / 4 + rgrid.ym) * (this.yr * this.yf)) + 'px'; 
    } 
 }

var rgrid = {
    // external variables
    NX  : 5, // amount X elements
    NY  : 5, // amount Y elements
    // internal variables
    mobj : null,
    doot : null,
    objects : new Array(),
    nx  : 0,
    ny  : 0,
    nxp  : 0,
    nyp  : 0,
    Ix  : 0,
    Iy  : 0,
    Ox  : 0,
    Oy  : 0,
    xm  : 0,
    ym  : 0,

    // main initialization function
    init : function(){
        this.mobj  = document.getElementById('grid'); 
        this.doot = document.getElementById('src_img'); 
        var k = 0; 
        for(var i=0; i<this.NY; i++) 
            for(var j=0;j<this.NX;j++) 
                this.objects[k++] = new CObj(i,j); 

        this.nxp = this.mobj.parentNode.offsetLeft / 2; 
        this.nyp = this.mobj.parentNode.offsetTop / 2; 
    },
    // resize function
    resize : function(){
        this.nx = this.mobj.offsetWidth; 
        this.ny = this.mobj.offsetHeight; 
        this.nxp = this.mobj.parentNode.offsetLeft / 2; 
        this.nyp = this.mobj.parentNode.offsetTop / 2; 
        this.Ix = this.doot.width; 
        this.Iy = this.doot.height; 
        this.Nx = Math.round(this.Ix / this.NX); 
        this.Ny = Math.round(this.Iy / this.NY); 
        this.Ox = (this.nx - this.Ix) / 2; 
        this.Oy = (this.ny - this.Iy) / 2; 
        var css = this.mobj.style; 
        css.left   = Math.round(this.Ox) + 'px'; 
        css.top    = Math.round(this.Oy) + 'px'; 
        css.width  = Math.round(this.Ix) + 'px'; 
        css.height = Math.round(this.Iy) + 'px'; 
        var i = 0, o; 
        while (o = this.objects[i++]) 
            o.init(); 
    },
    // main loop drawing function
    run : function(){
        var i = 0, o;
        while (o = rgrid.objects[i++]) 
            o.draw(); 
        setTimeout(rgrid.run, 20); 
    } 
}

// page onload
window.onload = function() {
    rgrid.init(); // perform initialization
    rgrid.resize(); // perform resizing
    rgrid.xm = rgrid.nx / 4 - Math.random() * 50; 
    rgrid.ym = rgrid.ny / 4 - Math.random() * 50; 
    rgrid.run(); 

    // binding onresize event
    window.onresize = rgrid.resize();
}

// binding onmousemove event
document.onmousemove = function(e){ 
    if (window.event) e = window.event; 
    rgrid.xm = ((e.x || e.clientX) / 2) - rgrid.nxp;
    rgrid.ym = ((e.y || e.clientY) / 2) - rgrid.nyp;
    if (Math.abs(2 * rgrid.xm - rgrid.nx / 2) < 2 && Math.abs(2 * rgrid.ym - rgrid.ny / 2) < 2){ 
        rgrid.xm = rgrid.nx / 4; 
        rgrid.ym = rgrid.ny / 4; 
    } 
} 